"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

// 因为有children，不好用PurComponent
var RenderMarkComp = /*#__PURE__*/function (_React$Component) {
  _inherits(RenderMarkComp, _React$Component);

  var _super = _createSuper(RenderMarkComp);

  function RenderMarkComp() {
    _classCallCheck(this, RenderMarkComp);

    return _super.apply(this, arguments);
  }

  _createClass(RenderMarkComp, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps) {
      // 无渲染标，直接渲染。有时候将包装组件作为普通组件使用时，就没有标记
      // console.log('nextProps.renderOptimizeMark:', nextProps.renderOptimizeMark)
      if (!nextProps.renderOptimizeMark) return true;
      if (nextProps.muteRenderOptimizeMark) return true;
      return this.props.renderOptimizeMark !== nextProps.renderOptimizeMark;
    }
  }, {
    key: "render",
    value: function render() {
      return this.props.children;
    }
  }]);

  return RenderMarkComp;
}(React.Component);

var defaultComponentName = 'SifoReactOptimise';

var componentWrap = function componentWrap(Component) {
  var compName = Component ? Component.name || Component.displayName || defaultComponentName : defaultComponentName;
  var wrapName = "".concat(compName, "RenderMarkWrap");

  var RenderMarkWrap = function RenderMarkWrap(props) {
    if (!Component) return null;

    var __renderOptimizeMark__ = props.__renderOptimizeMark__,
        _props$muteRenderOpti = props.muteRenderOptimizeMark,
        muteRenderOptimizeMark = _props$muteRenderOpti === void 0 ? false : _props$muteRenderOpti,
        other = _objectWithoutProperties(props, ["__renderOptimizeMark__", "muteRenderOptimizeMark"]);

    return /*#__PURE__*/React.createElement(RenderMarkComp, {
      renderOptimizeMark: __renderOptimizeMark__,
      muteRenderOptimizeMark: muteRenderOptimizeMark
    }, /*#__PURE__*/React.createElement(Component, other));
  };

  RenderMarkWrap.displayName = wrapName;
  return RenderMarkWrap;
};

var _default = componentWrap;
exports["default"] = _default;